﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CognitiveScience
{
    class Data
    {
        /* Subject
         1. Shivanshu Singla
         2. Shubham Toshniwal
         3. Siddharth Gaur
         4. Guruprasad Nayak
         5. Mukul Singh*/


        public static Tree t1=null, t2=null, t3=null, t4=null, t5=null;

        public static List<List<string>> user1 = new List<List<string>>();
        public static List<List<string>> user2 = new List<List<string>>();
        public static List<List<string>> user3 = new List<List<string>>();
        public static List<List<string>> user4 = new List<List<string>>();
        public static List<List<string>> user5 = new List<List<string>>();

        public static List<string> start = new List<string>() { "H5","MT","CC", "H7","LB" };

        public static List<string> target1 = new List<string>() { "LB", "AS", "FB", "LH", "H1", "CF" };
        public static List<string> target2 = new List<string>() { "KV", "SC", "TC", "CC", "AD", "WL" };
        public static List<string> target3 = new List<string>() { "HC", "MT", "H1", "H7", "LB", "AD" };
        public static List<string> target4 = new List<string>() { "CF", "H1", "EB", "LH", "KV", "TC" };
        public static List<string> target5 = new List<string>() { "CC", "NS", "MT", "SC", "LH", "FB" };

        public static void initUserResponse()
        {
            user1.Add(new List<string> { "H1", "LH", "LB", "FB", "AS", "CF" });
            user1.Add(new List<string> { "TC", "WL", "CC", "AD", "SC", "KV" });
            user1.Add(new List<string> { "AD", "LB", "MT", "H1", "H7", "HC" });
            user1.Add(new List<string> { "TC", "H1", "LH", "CF", "KV", "H1" });
            user1.Add(new List<string> { "SC", "CC", "FB", "LH", "MT", "NS" });


            user2.Add(new List<string> { "H1", "CF", "LH", "FB", "LB", "AS" });
            user2.Add(new List<string> { "TC", "KV", "SC", "AD", "CC", "WL" });
            user2.Add(new List<string> { "LB", "AD", "H1", "HC", "H7", "MT" });
            user2.Add(new List<string> { "TC", "H1", "CF", "KV", "LH", "EB" });
            user2.Add(new List<string> { "CC", "FB", "LH", "SC", "MT", "NS" });

            user3.Add(new List<string> { "H1", "LH", "LB", "FB", "AS", "CF" });
            user3.Add(new List<string> { "TC", "WL", "CC", "AD", "SC", "KV" });
            user3.Add(new List<string> { "AD", "LB", "H1", "MT", "H7", "HC" });
            user3.Add(new List<string> { "TC", "H1", "CF", "LH", "KV", "EB" });
            user3.Add(new List<string> { "LH", "FB", "CC", "SC", "MT", "NS" });


            user4.Add(new List<string> { "H1", "CF", "LH", "FB", "LB", "AS" });
            user4.Add(new List<string> { "TC", "KV", "SC", "AD", "CC", "WL" });
            user4.Add(new List<string> { "LB", "AD", "H1", "HC", "LB", "MT" });
            user4.Add(new List<string> { "TC", "H1", "CF", "KV", "LH", "EB" });
            user4.Add(new List<string> { "CC", "FB", "LH", "SC", "MT", "NS" });


            user5.Add(new List<string> { "", "", "", "", "", "" });
            user5.Add(new List<string> { "", "", "", "", "", "" });
            user5.Add(new List<string> { "", "", "", "", "", "" });
            user5.Add(new List<string> { "", "", "", "", "", "" });
            user5.Add(new List<string> { "", "", "", "", "", "" });
        }

        public static void initTree()
        {
            t1 = new Tree("region", 0, 0);
            t2 = new Tree("region", 0, 0);
            t3 = new Tree("region", 0, 0);
            t4 = new Tree("region", 0, 0);
            t5 = new Tree("region", 0, 0);

            for (int i = 0; i < 20; i++)
            {
                t1.insert(Program.landmarks[i], Program.latitude[i], Program.longitude[i]);
                t2.insert(Program.landmarks[i], Program.latitude[i], Program.longitude[i]);
                t3.insert(Program.landmarks[i], Program.latitude[i], Program.longitude[i]);
                t4.insert(Program.landmarks[i], Program.latitude[i], Program.longitude[i]);
                t5.insert(Program.landmarks[i], Program.latitude[i], Program.longitude[i]);   
            }

            //Tree 1 : Subject Shivanshu Singla
            t1.merge(new List<string>() { "LB", "LH", "WL" });
            Tree u = t1.merge(new List<string>() { "H1", "H2", "H3","H5","H7" });
            Tree v = t1.merge(new List<string>() { "HC", "NS"}).merge3("TC").merge3("MT");
            u.merge2(new List<Tree>() { u,v});
            t1.merge(new List<string>() { "SC", "CF" }).merge3("AD").merge3("KV");

            //Tree 2 :  Shubham Toshniwal
            u = t2.merge(new List<string>() { "H1","H2","H3","H5","H7"});
            v = t2.merge(new List<string>() { "CC", "LB", "WL" });
            t2.merge2(new List<Tree>() { t2.giveNode("LH"), t2.giveNode("FB"), v });
            t2.merge(new List<string>() { "SC","AD"});
            t2.merge(new List<string>() { "EB","AS"});
            
            //Tree 3 : Subject Siddharth Gaur            
            u=t3.merge(new List<string>() { "SC", "AD" });
            v=t3.merge(new List<string>() { "EB", "AS" });
            u = t3.merge2(new List<Tree>() { u, v });
            v = t3.merge(new List<string>() { "LH","LB"});
            v = t3.merge2(new List<Tree>() { t3.giveNode("CC"), v, t3.giveNode("FB"), t3.giveNode("WL") });
            u = t3.merge2(new List<Tree>() { u, v });
            v = t3.merge(new List<string> (){ "KV", "HC" }).merge3("MT");
            Tree z = t3.merge(new List<string>() { "TC","CF","NS"});
            t3.merge2(new List<Tree>() { u,v,z});

            //Tree 4 : Guruprasad Nayak
            Tree u2 = t4.merge(new List<string>() { "FB", "CC" }).merge3("LH");
            Tree u3 = t4.merge(new List<string>() { "AD", "SC" });
            Tree u4 = t4.merge(new List<string>() { "KV", "HC" });
            List<Tree> ls = new List<Tree>() { t4.giveNode("WL"), u2, u3, u4, t4.giveNode("TC"), t4.giveNode("NS"), t4.giveNode("AS"), t4.giveNode("CF"), t4.giveNode("MT"), t4.giveNode("LB") };
            t4.merge2(ls);

            //Tree 5 : Mukul Singh
            t5.merge(new List<string>() { "CF","KV"});
            t5.merge(new List<string> {"LB","FB" }).merge3("WL");
        }

    }
}
